/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
)

// checks if the MessageOrderStatus type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &MessageOrderStatus{}

// MessageOrderStatus struct for MessageOrderStatus
type MessageOrderStatus struct {
	ReferenceId string `json:"reference_id"`
	Status string `json:"status"`
	Description *string `json:"description,omitempty"`
}

// NewMessageOrderStatus instantiates a new MessageOrderStatus object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewMessageOrderStatus(referenceId string, status string) *MessageOrderStatus {
	this := MessageOrderStatus{}
	this.ReferenceId = referenceId
	this.Status = status
	return &this
}

// NewMessageOrderStatusWithDefaults instantiates a new MessageOrderStatus object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewMessageOrderStatusWithDefaults() *MessageOrderStatus {
	this := MessageOrderStatus{}
	var status string = "delivered"
	this.Status = status
	return &this
}

// GetReferenceId returns the ReferenceId field value
func (o *MessageOrderStatus) GetReferenceId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ReferenceId
}

// GetReferenceIdOk returns a tuple with the ReferenceId field value
// and a boolean to check if the value has been set.
func (o *MessageOrderStatus) GetReferenceIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ReferenceId, true
}

// SetReferenceId sets field value
func (o *MessageOrderStatus) SetReferenceId(v string) {
	o.ReferenceId = v
}

// GetStatus returns the Status field value
func (o *MessageOrderStatus) GetStatus() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Status
}

// GetStatusOk returns a tuple with the Status field value
// and a boolean to check if the value has been set.
func (o *MessageOrderStatus) GetStatusOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Status, true
}

// SetStatus sets field value
func (o *MessageOrderStatus) SetStatus(v string) {
	o.Status = v
}

// GetDescription returns the Description field value if set, zero value otherwise.
func (o *MessageOrderStatus) GetDescription() string {
	if o == nil || IsNil(o.Description) {
		var ret string
		return ret
	}
	return *o.Description
}

// GetDescriptionOk returns a tuple with the Description field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageOrderStatus) GetDescriptionOk() (*string, bool) {
	if o == nil || IsNil(o.Description) {
		return nil, false
	}
	return o.Description, true
}

// HasDescription returns a boolean if a field has been set.
func (o *MessageOrderStatus) HasDescription() bool {
	if o != nil && !IsNil(o.Description) {
		return true
	}

	return false
}

// SetDescription gets a reference to the given string and assigns it to the Description field.
func (o *MessageOrderStatus) SetDescription(v string) {
	o.Description = &v
}

func (o MessageOrderStatus) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o MessageOrderStatus) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["reference_id"] = o.ReferenceId
	toSerialize["status"] = o.Status
	if !IsNil(o.Description) {
		toSerialize["description"] = o.Description
	}
	return toSerialize, nil
}

type NullableMessageOrderStatus struct {
	value *MessageOrderStatus
	isSet bool
}

func (v NullableMessageOrderStatus) Get() *MessageOrderStatus {
	return v.value
}

func (v *NullableMessageOrderStatus) Set(val *MessageOrderStatus) {
	v.value = val
	v.isSet = true
}

func (v NullableMessageOrderStatus) IsSet() bool {
	return v.isSet
}

func (v *NullableMessageOrderStatus) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMessageOrderStatus(val *MessageOrderStatus) *NullableMessageOrderStatus {
	return &NullableMessageOrderStatus{value: val, isSet: true}
}

func (v NullableMessageOrderStatus) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMessageOrderStatus) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


